C  ENFORCE SYMMETRY IN ALL VOLUMETRIC OUTPUT TALLIES, I.E. ALL ESTIM(NTAL,NRAD)
C  LP: POLOIDAL SYMMETRY, SECOND GRID (IP=1,NP2ND) RESULTS ARE MADE SYMMETRIC
C      WRT. POSITION (NP2ND-1)/2
C  LT: TOROIDAL SYMMETRY, THIRD GRID (IT=1,NT3RD), RESULTS ARE MADE SYMMETRIC
C      WRT. POSITION (NT3RD-1)/2

C  TO BE DONE: THINK ABOUT SYMMETRISING DIRECTIONAL TALLIES, E.G. MOMENTUM SOURCES ???
C
      SUBROUTINE EIRENE_SYMET(ESTIM,NTAL,NRAD,NR1ST,NP2ND,NT3RD,
     .                 LP,LT)
C
C  SYMMETRISE TALLIES
C
      USE EIRMOD_PRECISION
      IMPLICIT NONE

      INTEGER, INTENT(IN) :: NTAL, NRAD, NR1ST, NP2ND, NT3RD
      REAL(DP), INTENT(INOUT) :: ESTIM(NTAL,NRAD)
      LOGICAL, INTENT(IN) :: LP,LT
      REAL(DP) :: SAV
      INTEGER :: IR, IP, IT, J1, J2, ITAL, NSYM, NSYH

      IF (LP) THEN
        NSYM=NP2ND
        NSYH=(NSYM-1)/2
        DO 30 ITAL=1,NTAL
          DO IR=1,NR1ST
            DO IT=1,NT3RD
              DO IP=1,NSYH
                J1=IR+((IT-1)*NP2ND+IP-1)*NR1ST
                J2=IR+((IT-1)*NP2ND+NSYM-IP-1)*NR1ST
                SAV=(ESTIM(ITAL,J1)+ESTIM(ITAL,J2))*0.5
                ESTIM(ITAL,J1)=SAV
                ESTIM(ITAL,J2)=SAV
              END DO
            END DO
          END DO
   30   CONTINUE
      ENDIF

      IF (LT) THEN
        NSYM=NT3RD
        NSYH=(NSYM-1)/2
        DO 130 ITAL=1,NTAL
          DO IR=1,NR1ST
            DO IP=1,NP2ND
              DO IT=1,NSYH
                J1=IR+((IT-1)*NP2ND+IP-1)*NR1ST
                J2=IR+((NSYM-IT-1)*NP2ND+IP-1)*NR1ST
                SAV=(ESTIM(ITAL,J1)+ESTIM(ITAL,J2))*0.5
                ESTIM(ITAL,J1)=SAV
                ESTIM(ITAL,J2)=SAV
              END DO
            END DO
          END DO
  130   CONTINUE
      ENDIF

      RETURN
      END SUBROUTINE EIRENE_SYMET
