C
C
      SUBROUTINE EIRENE_SURTST(X,Y,Z,N,L)
C
C  THIS SUBROUTINE TESTS, WHETHER A POINT X,Y,Z FULLFILLS THE
C  THE BOUNDARY CONDITIONS FOR THE ADDITIONAL SURFACE NO. N OR NOT
C
      USE EIRMOD_PRECISION
      USE EIRMOD_PARMMOD
      USE EIRMOD_CADGEO
      USE EIRMOD_COMPRT, ONLY: IUNOUT

      IMPLICIT NONE

      REAL(DP), INTENT(IN) :: X, Y, Z
      INTEGER, INTENT(IN) :: N
      LOGICAL, INTENT(OUT) :: L
      REAL(DP) :: XMS1, XMS2, XMS3, XLS1, XLS2, XLS3
      INTEGER :: I
      EXTERNAL :: EIRENE_EXIT_OWN

      L=.TRUE.
      IF (RLB(N).EQ.1..OR.RLB(N).EQ.1.5) THEN
               L=L.AND.XLIMS1(1,N).LE.X.AND.X.LE.XLIMS2(1,N)
     .            .AND.YLIMS1(1,N).LE.Y.AND.Y.LE.YLIMS2(1,N)
     .            .AND.ZLIMS1(1,N).LE.Z.AND.Z.LE.ZLIMS2(1,N)
        IF (RLB(N).EQ.1.5) L=.NOT.L
      ELSEIF (RLB(N).LE.0.D0) THEN
        DO 1 I=1,ILIN(N)
           L=L.AND.
     .       ALIMS(I,N)+XLIMS(I,N)*X+YLIMS(I,N)*Y+ZLIMS(I,N)*Z.LE.0.
    1   CONTINUE
        DO 2 I=1,ISCN(N)
           L=L.AND.
     .        ALIMS0(I,N)+XLIMS1(I,N)*X+YLIMS1(I,N)*Y+ZLIMS1(I,N)*Z
     .       +XLIMS2(I,N)*X*X+YLIMS2(I,N)*Y*Y+ZLIMS2(I,N)*Z*Z
     .       +XLIMS3(I,N)*X*Y+YLIMS3(I,N)*X*Z+ZLIMS3(I,N)*Y*Z.LE.0.
    2   CONTINUE
      ELSEIF (RLB(N).GE.3.) THEN
        XMS1=X*PS13(1,N)+Y*PS13(2,N)+Z*PS13(3,N)+P1A(N)
        XLS1=X*PS23(1,N)+Y*PS23(2,N)+Z*PS23(3,N)+P2A(N)
        L=XMS1.GE.0..AND.XLS1.GE.0..AND.XMS1+XLS1.LE.1.
        IF (RLB(N).GE.4.AND..NOT.L) THEN
          XMS2=X*PS24(1,N)+Y*PS24(2,N)+Z*PS24(3,N)+P1B(N)
          XLS2=X*PS34(1,N)+Y*PS34(2,N)+Z*PS34(3,N)+P2B(N)
          L=XMS2.GE.0..AND.XLS2.GE.0..AND.XMS2+XLS2.LE.1.
          IF (RLB(N).GE.5.AND..NOT.L) THEN
            XMS3=X*PS35(1,N)+Y*PS35(2,N)+Z*PS35(3,N)+P1C(N)
            XLS3=X*PS45(1,N)+Y*PS45(2,N)+Z*PS45(3,N)+P2C(N)
            L=XMS3.GE.0..AND.XLS3.GE.0..AND.XMS3+XLS3.LE.1.
          ENDIF
        ENDIF
      ELSE
        WRITE (iunout,*)
     .  'ERROR IN SUBROUTINE EIRENE_SURTST. RLB= ',RLB(N)
        CALL EIRENE_EXIT_OWN(1)
      ENDIF
      RETURN
      END SUBROUTINE EIRENE_SURTST
