C  SCORE ADDITIONAL COUPLE TALLIES FOR B2/B2.5 COUPLING.
C  CURRENTLY ONLY THE E0/EP-1
C  WEIGHTED CX RATE IS SCORED ON COPV(1:NPLSI,IRAD)
C  ATOMIC CONTRIBUTION ONLY, IPLS RESOLVED

cdr  jan 17:  remove allocatable cndyn arrays, as these are now
cdr           set in initialization routines.
cdr  jan 18:  remove unused radial and poloidal velocity components VR and VP, resp.

C  IN OLDER VERSION OF UPTCOP.F FOR B2/B2.5 INTERFACES ALSO PARALLEL MOMENTUM
C  SOURCES HAVE BEEN SCORED HERE. THESE, HOWEVER, ARE NOW DEFAULT EIRENE TALLIES.
C
      SUBROUTINE EIRENE_UPTCOP(XSTOR2,XSTORV2,WV)
C
C  USER-SUPPLIED TRACKLENGTH ESTIMATOR, VOLUME-AVERAGED, FOR CODE INTERFACING
C
      USE EIRMOD_PRECISION
      USE EIRMOD_PARMMOD
      USE EIRMOD_COMUSR
      USE EIRMOD_CESTIM
      USE EIRMOD_CCONA
      USE EIRMOD_CLOGAU
      USE EIRMOD_CUPD
      USE EIRMOD_CPOLYG
      USE EIRMOD_CGRID
      USE EIRMOD_CSPEZ
      USE EIRMOD_CZT1
      USE EIRMOD_CGEOM
      USE EIRMOD_COMPRT
      USE EIRMOD_CSDVI
      USE EIRMOD_COMXS

      IMPLICIT NONE

      REAL(DP), INTENT(IN) :: XSTOR2(MSTOR1,MSTOR2,N2ND+N3RD),
     .                        XSTORV2(NSTORV,N2ND+N3RD), WV

      REAL(DP) :: P, WTRSIG, EEION, V0_PARB, PARMOM_0, DIST, WTR
      INTEGER :: IAEL, IREL, IPL2, IAEI, IRDS, IBGK, IICX, IIEI, IIEL,
     .           IMEL, IPL1, I, IPL, IIO, IRD, IP, IR, IML, IAT, IFIRST,
     .           IRCX, IADD, ICOU, IACX, IRDD, IMCX, IMEI, IPLSTI,
     .           IPLSV, IPLV
      INTEGER, SAVE :: NMTSP

CDR
!     REAL(DP), ALLOCATABLE, SAVE ::
!    .         VPX(:),    VPY(:),    VRX(:),    VRY(:)
CDR
      DATA IFIRST/0/
      SAVE
      IF (IFIRST.EQ.0) THEN
        IFIRST=1

!       ALLOCATE (VPX(NRAD))
!       ALLOCATE (VPY(NRAD))
!       ALLOCATE (VRX(NRAD))
!       ALLOCATE (VRY(NRAD))
C
CDR
CDR  PROVIDE A RADIAL UNIT VECTOR PER CELL
CDR  VPX,VPY,  NEEDED FOR PROJECTING PARTICLE VELOCITIES
C
CDR  SAME FOR POLOIDAL UNIT VECTOR VRX,VRY
C
!       DO 1 I=1,NRAD
!         VPX(I)=0.
!         VPY(I)=0.
!         VRX(I)=0.
!         VRY(I)=0.
!1      CONTINUE
!       DO 2 IR=1,NR1STM
!         DO 2 IP=1,NP2NDM
!           IRD=IR+(IP-1)*NR1P2
!           VPX(IRD)=PLNX(IR,IP)
!           VPY(IRD)=PLNY(IR,IP)
!           VRX(IRD)=PPLNX(IR,IP)
!           VRY(IRD)=PPLNY(IR,IP)
!2      CONTINUE
C
        NMTSP=NPHOTI+NATMI+NMOLI+NIONI+NPLSI+NADVI+NALVI+NCLVI
C
      ENDIF
C
C  WV=WEIGHT/VEL
C
C  ATOMS
      IF (ITYP.EQ.1) THEN
        DO 20 ICOU=1,NCOU
          DIST=CLPD(ICOU)
          WTR=WV*DIST
          IRD=NRCELL+NUPC(ICOU)*NR1P2+NBLCKA
          IRDD=NCLTAL(IRD)
C
          IF (LGVAC(IRD,0)) GOTO 20
C
          if (ncou.gt.1) then
            XSTOR(:,:) = XSTOR2(:,:,ICOU)
            XSTORV(:) = XSTORV2(:,ICOU)
          endif
C
C  1,NPLSI:
C              PARTICLE CHARGE EXCHANGE RATE DUE TO IPLS: #/S
C              WITH ATOM SPECIES IATM=1,NATMI, PER ION
C  EACH RATE IS WEIGHTED WITH THE FACTOR (E0/EI-1), E0 BEING
C  THE NEUTRAL PARTICLE ENERGY, EI THE MEAN PLASMA ION ENERGY
C  THESE RATES ARE SCALED IN THE SHORT CYCLE WITH EI*NI
C
C
          IF (LGACX(IATM,0,0).EQ.0) GOTO 51
          IF (NCPVI >= NPLSI) THEN
            DO 52 IACX=1,NACXI(IATM)
              IRCX=LGACX(IATM,IACX,0)
              IPLS=LGACX(IATM,IACX,1)
              IF (LGVAC(IRD,IPLS)) GOTO 52
              IPLSTI= MPLSTI(IPLS)
              EEION=1.5*TIIN(IPLSTI,IRD)
              IF (LEDRIFT) EEION = EEION + EDRIFT(IPLS,IRD)
              WTRSIG=WTR*SIGVCX(IRCX)/DIIN(IPLS,IRD)
              COPV(IPLS,IRDD)=COPV(IPLS,IRDD)+WTRSIG*(E0/EEION-1.)
              LMETSP(NMTSP+IPLS)=.TRUE.
   52       CONTINUE
          END IF
   51     CONTINUE
C
   20   CONTINUE
C
C  MOLECULES
      ELSEIF (ITYP.EQ.2) THEN
C
C
C  TEST IONS
C
      ELSEIF (ITYP.EQ.3) THEN
C
C
C
      ENDIF
C
      RETURN
      END
