cdr  dec. 15:  added species index ipls for energy source rates for bulk ions:
cdr            eapl,empl,eipl,ephpl,eppl

C
      SUBROUTINE EIRENE_SUM_AVERAGE (ISTRA)
C
C  MONTE CARLO CALCULATION
C
      USE EIRMOD_PARMMOD
      USE EIRMOD_COMUSR
      USE EIRMOD_COUTAU
      USE EIRMOD_CSPEZ
      USE EIRMOD_CESTIM
      USE EIRMOD_CLGIN
      USE EIRMOD_CLOGAU

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: ISTRA
      INTEGER :: J, IATM, IMOL, IION, IPLS, IPHOT, ISPZ, IADV, ICLV,
     .           ISNV, ICPV, IBGV
C
C   SUM OVER SURFACE INDEX
C   IN THE SURFACE-AVERAGED ESTIMATORS
C
      DO 632 IMOL=1,NMOLI
        IF (.NOT.LOGMOL(IMOL,ISTRA)) CYCLE
        DO 633 J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LPRFAML) THEN
            IF (NLSPCSCL_ATM) THEN
              PRFAML2(1:NMOL,0:NATM) => PRFAML(:,J)
              PRFAMI2(0:NMOL,0:NATM) => PRFAMI(:,ISTRA)
              PRFAMI2(IMOL,:) = PRFAMI2(IMOL,:)+PRFAML2(IMOL,:)
            ELSE
              PRFAMI(IMOL,ISTRA)=PRFAMI(IMOL,ISTRA)+PRFAML(IMOL,J)
            END IF
          END IF
          IF (LPRFMML) THEN
            IF (NLSPCSCL_MOL) THEN
              PRFMML2(1:NMOL,0:NMOL) => PRFMML(:,J)
              PRFMMI2(0:NMOL,0:NMOL) => PRFMMI(:,ISTRA)
              PRFMMI2(IMOL,:) = PRFMMI2(IMOL,:)+PRFMML2(IMOL,:)
            ELSE
              PRFMMI(IMOL,ISTRA)=PRFMMI(IMOL,ISTRA)+PRFMML(IMOL,J)
            END IF
          END IF
          IF (LPRFIML) THEN
            IF (NLSPCSCL_ION) THEN
              PRFIML2(1:NMOL,0:NION) => PRFIML(:,J)
              PRFIMI2(0:NMOL,0:NION) => PRFIMI(:,ISTRA)
              PRFIMI2(IMOL,:) = PRFIMI2(IMOL,:)+PRFIML2(IMOL,:)
            ELSE
              PRFIMI(IMOL,ISTRA)=PRFIMI(IMOL,ISTRA)+PRFIML(IMOL,J)
            END IF
          END IF
          IF (LPRFPHML) THEN
            IF (NLSPCSCL_PHOT) THEN
              PRFPHML2(1:NMOL,0:NPHOT) => PRFPHML(:,J)
              PRFPHMI2(0:NMOL,0:NPHOT) => PRFPMI(:,ISTRA)
              PRFPHMI2(IMOL,:) = PRFPHMI2(IMOL,:)+PRFPHML2(IMOL,:)
            ELSE
              PRFPHMI(IMOL,ISTRA)=PRFPHMI(IMOL,ISTRA)+PRFPHML(IMOL,J)
            END IF
          END IF
          IF (LPRFPML)
     .      PRFPMI(IMOL,ISTRA)=PRFPMI(IMOL,ISTRA)+PRFPML(IMOL,J)
          IF (LPOTML)
     .      POTMLI(IMOL,ISTRA)=POTMLI(IMOL,ISTRA)-POTML(IMOL,J)
          IF (LERFAML)
     .      ERFAMI(IMOL,ISTRA)=ERFAMI(IMOL,ISTRA)+ERFAML(IMOL,J)
          IF (LERFMML)
     .      ERFMMI(IMOL,ISTRA)=ERFMMI(IMOL,ISTRA)+ERFMML(IMOL,J)
          IF (LERFIML)
     .      ERFIMI(IMOL,ISTRA)=ERFIMI(IMOL,ISTRA)+ERFIML(IMOL,J)
          IF (LERFPHML)
     .      ERFPHMI(IMOL,ISTRA)=ERFPHMI(IMOL,ISTRA)+ERFPHML(IMOL,J)
          IF (LERFPML)
     .      ERFPMI(IMOL,ISTRA)=ERFPMI(IMOL,ISTRA)+ERFPML(IMOL,J)
          IF (LEOTML)
     .      EOTMLI(IMOL,ISTRA)=EOTMLI(IMOL,ISTRA)-EOTML(IMOL,J)
          IF (LSPTAML)
     .      SPTAMLI(IMOL,ISTRA)=SPTAMLI(IMOL,ISTRA)+SPTAML(IMOL,J)
          IF (LSPTMML)
     .      SPTMMLI(IMOL,ISTRA)=SPTMMLI(IMOL,ISTRA)+SPTMML(IMOL,J)
          IF (LSPTIML)
     .      SPTIMLI(IMOL,ISTRA)=SPTIMLI(IMOL,ISTRA)+SPTIML(IMOL,J)
          IF (LSPTPHML)
     .      SPTPHMLI(IMOL,ISTRA)=SPTPHMLI(IMOL,ISTRA)+SPTPHML(IMOL,J)
          IF (LSPTPML)
     .      SPTPMLI(IMOL,ISTRA)=SPTPMLI(IMOL,ISTRA)+SPTPML(IMOL,J)
  633   CONTINUE
  632 CONTINUE
C
      DO 635 IATM=1,NATMI
        IF (.NOT.LOGATM(IATM,ISTRA)) CYCLE
        DO 636 J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LPRFAAT) THEN
            IF (NLSPCSCL_ATM) THEN
              PRFAAT2(1:NATM,0:NATM) => PRFAAT(:,J)
              PRFAAI2(0:NATM,0:NATM) => PRFAAI(:,ISTRA)
              PRFAAI2(IATM,:) = PRFAAI2(IATM,:)+PRFAAT2(IATM,:)
            ELSE
              PRFAAI(IATM,ISTRA)=PRFAAI(IATM,ISTRA)+PRFAAT(IATM,J)
            END IF
          END IF
          IF (LPRFMAT) THEN
            IF (NLSPCSCL_MOL) THEN
              PRFMAT2(1:NATM,0:NMOL) => PRFMAT(:,J)
              PRFMAI2(0:NATM,0:NMOL) => PRFMAI(:,ISTRA)
              PRFMAI2(IATM,:) = PRFMAI2(IATM,:)+PRFMAT2(IATM,:)
            ELSE
              PRFMAI(IATM,ISTRA)=PRFMAI(IATM,ISTRA)+PRFMAT(IATM,J)
            END IF
          END IF
          IF (LPRFIAT) THEN
            IF (NLSPCSCL_ION) THEN
              PRFIAT2(1:NATM,0:NION) => PRFIAT(:,J)
              PRFIAI2(0:NATM,0:NION) => PRFIAI(:,ISTRA)
              PRFIAI2(IATM,:) = PRFIAI2(IATM,:)+PRFIAT2(IATM,:)
            ELSE
              PRFIAI(IATM,ISTRA)=PRFIAI(IATM,ISTRA)+PRFIAT(IATM,J)
            END IF
          END IF
          IF (LPRFPHAT) THEN
            IF (NLSPCSCL_PHOT) THEN
              PRFPHAT2(1:NATM,0:NPHOT) => PRFPHAT(:,J)
              PRFPHAI2(0:NATM,0:NPHOT) => PRFPHAI(:,ISTRA)
              PRFPHAI2(IATM,:) = PRFPHAI2(IATM,:)+PRFPHAT2(IATM,:)
            ELSE
              PRFPHAI(IATM,ISTRA)=PRFPHAI(IATM,ISTRA)+PRFPHAT(IATM,J)
            END IF
          END IF
          IF (LPRFPAT)
     .      PRFPAI(IATM,ISTRA)=PRFPAI(IATM,ISTRA)+PRFPAT(IATM,J)
          IF (LPOTAT)
     .      POTATI(IATM,ISTRA)=POTATI(IATM,ISTRA)-POTAT(IATM,J)
          IF (LERFAAT)
     .      ERFAAI(IATM,ISTRA)=ERFAAI(IATM,ISTRA)+ERFAAT(IATM,J)
          IF (LERFMAT)
     .      ERFMAI(IATM,ISTRA)=ERFMAI(IATM,ISTRA)+ERFMAT(IATM,J)
          IF (LERFIAT)
     .      ERFIAI(IATM,ISTRA)=ERFIAI(IATM,ISTRA)+ERFIAT(IATM,J)
          IF (LERFPHAT)
     .      ERFPHAI(IATM,ISTRA)=ERFPHAI(IATM,ISTRA)+ERFPHAT(IATM,J)
          IF (LERFPAT)
     .      ERFPAI(IATM,ISTRA)=ERFPAI(IATM,ISTRA)+ERFPAT(IATM,J)
          IF (LEOTAT)
     .      EOTATI(IATM,ISTRA)=EOTATI(IATM,ISTRA)-EOTAT(IATM,J)
          IF (LSPTAAT)
     .      SPTAATI(IATM,ISTRA)=SPTAATI(IATM,ISTRA)+SPTAAT(IATM,J)
          IF (LSPTMAT)
     .      SPTMATI(IATM,ISTRA)=SPTMATI(IATM,ISTRA)+SPTMAT(IATM,J)
          IF (LSPTIAT)
     .      SPTIATI(IATM,ISTRA)=SPTIATI(IATM,ISTRA)+SPTIAT(IATM,J)
          IF (LSPTPHAT)
     .      SPTPHATI(IATM,ISTRA)=SPTPHATI(IATM,ISTRA)+SPTPHAT(IATM,J)
          IF (LSPTPAT)
     .      SPTPATI(IATM,ISTRA)=SPTPATI(IATM,ISTRA)+SPTPAT(IATM,J)
  636   CONTINUE
  635 CONTINUE
C
      DO 638 IION=1,NIONI
        IF (.NOT.LOGION(IION,ISTRA)) CYCLE
        DO 639 J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LPRFAIO) THEN
            IF (NLSPCSCL_ATM) THEN
              PRFAIO2(1:NION,0:NATM) => PRFAIO(:,J)
              PRFAII2(0:NION,0:NATM) => PRFAII(:,ISTRA)
              PRFAII2(IION,:) = PRFAII2(IION,:)+PRFAIO2(IION,:)
            ELSE
              PRFAII(IION,ISTRA)=PRFAII(IION,ISTRA)+PRFAIO(IION,J)
            END IF
          END IF
          IF (LPRFMIO) THEN
            IF (NLSPCSCL_MOL) THEN
              PRFMIO2(1:NION,0:NMOL) => PRFMIO(:,J)
              PRFMII2(0:NION,0:NMOL) => PRFMII(:,ISTRA)
              PRFMII2(IION,:) = PRFMII2(IION,:)+PRFMIO2(IION,:)
            ELSE
              PRFMII(IION,ISTRA)=PRFMII(IION,ISTRA)+PRFMIO(IION,J)
            END IF
          END IF
          IF (LPRFIIO) THEN
            IF (NLSPCSCL_ION) THEN
              PRFIIO2(1:NION,0:NION) => PRFIIO(:,J)
              PRFIII2(0:NION,0:NION) => PRFIII(:,ISTRA)
              PRFIII2(IION,:) = PRFIII2(IION,:)+PRFIIO2(IION,:)
            ELSE
              PRFIII(IION,ISTRA)=PRFIII(IION,ISTRA)+PRFIIO(IION,J)
            END IF
          END IF
          IF (LPRFPHIO) THEN
            IF (NLSPCSCL_PHOT) THEN
              PRFPHIO2(1:NION,0:NPHOT) => PRFPHIO(:,J)
              PRFPHII2(0:NION,0:NPHOT) => PRFPHII(:,ISTRA)
              PRFPHII2(IION,:) = PRFPHII2(IION,:)+PRFPHIO2(IION,:)
            ELSE
              PRFPHII(IION,ISTRA)=PRFPHII(IION,ISTRA)+PRFPHIO(IION,J)
            END IF
          END IF
          IF (LPRFPIO)
     .      PRFPII(IION,ISTRA)=PRFPII(IION,ISTRA)+PRFPIO(IION,J)
          IF (LPOTIO)
     .      POTIOI(IION,ISTRA)=POTIOI(IION,ISTRA)-POTIO(IION,J)
          IF (LERFAIO)
     .      ERFAII(IION,ISTRA)=ERFAII(IION,ISTRA)+ERFAIO(IION,J)
          IF (LERFMIO)
     .      ERFMII(IION,ISTRA)=ERFMII(IION,ISTRA)+ERFMIO(IION,J)
          IF (LERFIIO)
     .      ERFIII(IION,ISTRA)=ERFIII(IION,ISTRA)+ERFIIO(IION,J)
          IF (LERFPHIO)
     .      ERFPHII(IION,ISTRA)=ERFPHII(IION,ISTRA)+ERFPHIO(IION,J)
          IF (LERFPIO)
     .      ERFPII(IION,ISTRA)=ERFPII(IION,ISTRA)+ERFPIO(IION,J)
          IF (LEOTIO)
     .      EOTIOI(IION,ISTRA)=EOTIOI(IION,ISTRA)-EOTIO(IION,J)
          IF (LSPTAIO)
     .      SPTAIOI(IION,ISTRA)=SPTAIOI(IION,ISTRA)+SPTAIO(IION,J)
          IF (LSPTMIO)
     .      SPTMIOI(IION,ISTRA)=SPTMIOI(IION,ISTRA)+SPTMIO(IION,J)
          IF (LSPTIIO)
     .      SPTIIOI(IION,ISTRA)=SPTIIOI(IION,ISTRA)+SPTIIO(IION,J)
          IF (LSPTPHIO)
     .      SPTPHIOI(IION,ISTRA)=SPTPHIOI(IION,ISTRA)+SPTPHIO(IION,J)
          IF (LSPTPIO)
     .      SPTPIOI(IION,ISTRA)=SPTPIOI(IION,ISTRA)+SPTPIO(IION,J)
  639   CONTINUE
  638 CONTINUE
C
      DO IPHOT=1,NPHOTI
        IF (.NOT.LOGPHOT(IPHOT,ISTRA)) CYCLE
        DO J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LPRFAPHT) THEN
            IF (NLSPCSCL_ATM) THEN
              PRFAPHT2(1:NPHOT,0:NATM) => PRFAPHT(:,J)
              PRFAPHTI2(0:NPHOT,0:NATM) => PRFAPHTI(:,ISTRA)
              PRFAPHTI2(IPHOT,:) = PRFAPHTI2(IPHOT,:)+PRFAPHT2(IPHOT,:)
            ELSE
              PRFAPHTI(IPHOT,ISTRA)=PRFAPHTI(IPHOT,ISTRA)+
     .                              PRFAPHT(IPHOT,J)
            END IF
          END IF
          IF (LPRFMPHT) THEN
            IF (NLSPCSCL_MOL) THEN
              PRFMPHT2(1:NPHOT,0:NMOL) => PRFMPHT(:,J)
              PRFMPHTI2(0:NPHOT,0:NMOL) => PRFMPHTI(:,ISTRA)
              PRFMPHTI2(IPHOT,:) = PRFMPHTI2(IPHOT,:)+PRFMPHT2(IPHOT,:)
            ELSE
              PRFMPHTI(IPHOT,ISTRA)=PRFMPHTI(IPHOT,ISTRA)+
     .                              PRFMPHT(IPHOT,J)
            END IF
          END IF
          IF (LPRFIPHT) THEN
            IF (NLSPCSCL_ION) THEN
              PRFIPHT2(1:NPHOT,0:NION) => PRFIPHT(:,J)
              PRFIPHTI2(0:NPHOT,0:NION) => PRFIPHTI(:,ISTRA)
              PRFIPHTI2(IPHOT,:) = PRFIPHTI2(IPHOT,:)+PRFIPHT2(IPHOT,:)
            ELSE
              PRFIPHTI(IPHOT,ISTRA)=PRFIPHTI(IPHOT,ISTRA)+
     .                              PRFIPHT(IPHOT,J)
            END IF
          END IF
          IF (LPRFPHPHT) THEN
            IF (NLSPCSCL_PHOT) THEN
              PRFPHPHT2(1:NPHOT,0:NPHOT) => PRFPHPHT(:,J)
              PRFPHPHTI2(0:NPHOT,0:NPHOT) => PRFPHPHTI(:,ISTRA)
              PRFPHPHTI2(IPHOT,:) = PRFPHPHTI2(IPHOT,:)+
     .                              PRFPHPHT2(IPHOT,:)
            ELSE
              PRFPHPHTI(IPHOT,ISTRA)=PRFPHPHTI(IPHOT,ISTRA)+
     .                               PRFPHPHT(IPHOT,J)
            END IF
          END IF
          IF (LPRFPPHT)
     .      PRFPPHTI(IPHOT,ISTRA)=PRFPPHTI(IPHOT,ISTRA)+PRFPPHT(IPHOT,J)
          IF (LPOTPHT)
     .      POTPHTI(IPHOT,ISTRA)=POTPHTI(IPHOT,ISTRA)-POTPHT(IPHOT,J)
          IF (LERFAPHT)
     .      ERFAPHTI(IPHOT,ISTRA)=ERFAPHTI(IPHOT,ISTRA)+ERFAPHT(IPHOT,J)
          IF (LERFMPHT)
     .      ERFMPHTI(IPHOT,ISTRA)=ERFMPHTI(IPHOT,ISTRA)+ERFMPHT(IPHOT,J)
          IF (LERFIPHT)
     .      ERFIPHTI(IPHOT,ISTRA)=ERFIPHTI(IPHOT,ISTRA)+ERFIPHT(IPHOT,J)
          IF (LERFPHPHT)
     .      ERFPHPHTI(IPHOT,ISTRA)=ERFPHPHTI(IPHOT,ISTRA)+
     .                           ERFPHPHT(IPHOT,J)
          IF (LERFPPHT)
     .      ERFPPHTI(IPHOT,ISTRA)=ERFPPHTI(IPHOT,ISTRA)+ERFPPHT(IPHOT,J)
          IF (LEOTPHT)
     .      EOTPHTI(IPHOT,ISTRA)=EOTPHTI(IPHOT,ISTRA)-EOTPHT(IPHOT,J)
          IF (LSPTAPHT)
     .      SPTAPHTI(IPHOT,ISTRA)=SPTAPHTI(IPHOT,ISTRA)+SPTAPHT(IPHOT,J)
          IF (LSPTMPHT)
     .      SPTMPHTI(IPHOT,ISTRA)=SPTMPHTI(IPHOT,ISTRA)+SPTMPHT(IPHOT,J)
          IF (LSPTIPHT)
     .      SPTIPHTI(IPHOT,ISTRA)=SPTIPHTI(IPHOT,ISTRA)+SPTIPHT(IPHOT,J)
          IF (LSPTPHPHT)
     .      SPTPHPHTI(IPHOT,ISTRA)=SPTPHPHTI(IPHOT,ISTRA)+
     .                             SPTPHPHT(IPHOT,J)
          IF (LSPTPPHT)
     .      SPTPPHTI(IPHOT,ISTRA)=SPTPPHTI(IPHOT,ISTRA)+SPTPPHT(IPHOT,J)
        END DO
      END DO
C
      DO 641 IPLS=1,NPLSI
        IF (.NOT.LOGPLS(IPLS,ISTRA)) CYCLE
        DO 642 J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LPOTPL)
     .      POTPLI(IPLS,ISTRA)=POTPLI(IPLS,ISTRA)-POTPL(IPLS,J)
          IF (LEOTPL)
     .      EOTPLI(IPLS,ISTRA)=EOTPLI(IPLS,ISTRA)-EOTPL(IPLS,J)
          IF (LSPTAPL)
     .      SPTAPLI(IPLS,ISTRA)=SPTAPLI(IPLS,ISTRA)+SPTAPL(IPLS,J)
          IF (LSPTMPL)
     .      SPTMPLI(IPLS,ISTRA)=SPTMPLI(IPLS,ISTRA)+SPTMPL(IPLS,J)
          IF (LSPTIPL)
     .      SPTIPLI(IPLS,ISTRA)=SPTIPLI(IPLS,ISTRA)+SPTIPL(IPLS,J)
          IF (LSPTPHPL)
     .      SPTPHPLI(IPLS,ISTRA)=SPTPHPLI(IPLS,ISTRA)+SPTPHPL(IPLS,J)
          IF (LSPTPPL)
     .      SPTPPLI(IPLS,ISTRA)=SPTPPLI(IPLS,ISTRA)+SPTPPL(IPLS,J)
  642   CONTINUE
  641 CONTINUE
C
      DO 651 ISPZ=1,NSPTOT
        DO 652 J=1,NLIMPS
          IF (ILIIN(J).LE.0) CYCLE
          IF (LSPUMP)
     .      SPUMPI(ISPZ,ISTRA)=SPUMPI(ISPZ,ISTRA)+SPUMP(ISPZ,J)
  652   CONTINUE
  651 CONTINUE

      DO J=1,NLIMPS
        IF (LSPTTOT)
     .    SPTTTI(ISTRA) = SPTTTI(ISTRA) + SPTTOT(J)
        IF (LSPTATOT)
     .    SPTATTI(ISTRA) = SPTATTI(ISTRA) + SPTATOT(J)
        IF (LSPTMTOT)
     .    SPTMTTI(ISTRA) = SPTMTTI(ISTRA) + SPTMTOT(J)
        IF (LSPTITOT)
     .    SPTITTI(ISTRA) = SPTITTI(ISTRA) + SPTITOT(J)
        IF (LSPTPHTOT)
     .    SPTPHTTI(ISTRA) = SPTPHTTI(ISTRA) + SPTPHTOT(J)
        IF (LSPTPLTOT)
     .    SPTPLTTI(ISTRA) = SPTPLTTI(ISTRA) + SPTPLTOT(J)
      END DO
C
C  SUM OVER SPECIES INDEX FOR INTEGRATED VOLUME-AVERAGED TALLIES
C                         AND INTEGRATED SURFACE-AVERAGED TALLIES
C
      DO 661 IPLS=1,NPLSI
        PAPLI(0,ISTRA)=PAPLI(0,ISTRA)+PAPLI(IPLS,ISTRA)
        PMPLI(0,ISTRA)=PMPLI(0,ISTRA)+PMPLI(IPLS,ISTRA)
        PIPLI(0,ISTRA)=PIPLI(0,ISTRA)+PIPLI(IPLS,ISTRA)
        PPHPLI(0,ISTRA)=PPHPLI(0,ISTRA)+PPHPLI(IPLS,ISTRA)
        PPPLI(0,ISTRA)=PPPLI(0,ISTRA)+PPPLI(IPLS,ISTRA)
        EAPLI(0,ISTRA)=EAPLI(0,ISTRA)+EAPLI(IPLS,ISTRA)
        EMPLI(0,ISTRA)=EMPLI(0,ISTRA)+EMPLI(IPLS,ISTRA)
        EIPLI(0,ISTRA)=EIPLI(0,ISTRA)+EIPLI(IPLS,ISTRA)
        EPHPLI(0,ISTRA)=EPHPLI(0,ISTRA)+EPHPLI(IPLS,ISTRA)
        EPPLI(0,ISTRA)=EPPLI(0,ISTRA)+EPPLI(IPLS,ISTRA)
        POTPLI(0,ISTRA)=POTPLI(0,ISTRA)+POTPLI(IPLS,ISTRA)
        EOTPLI(0,ISTRA)=EOTPLI(0,ISTRA)+EOTPLI(IPLS,ISTRA)
        SPTAPLI(0,ISTRA)=SPTAPLI(0,ISTRA)+SPTAPLI(IPLS,ISTRA)
        SPTMPLI(0,ISTRA)=SPTMPLI(0,ISTRA)+SPTMPLI(IPLS,ISTRA)
        SPTIPLI(0,ISTRA)=SPTIPLI(0,ISTRA)+SPTIPLI(IPLS,ISTRA)
        SPTPHPLI(0,ISTRA)=SPTPHPLI(0,ISTRA)+SPTPHPLI(IPLS,ISTRA)
        SPTPPLI(0,ISTRA)=SPTPPLI(0,ISTRA)+SPTPPLI(IPLS,ISTRA)
        MAPLI(0,ISTRA)=MAPLI(0,ISTRA)+MAPLI(IPLS,ISTRA)
        MMPLI(0,ISTRA)=MMPLI(0,ISTRA)+MMPLI(IPLS,ISTRA)
        MIPLI(0,ISTRA)=MIPLI(0,ISTRA)+MIPLI(IPLS,ISTRA)
        MPHPLI(0,ISTRA)=MPHPLI(0,ISTRA)+MPHPLI(IPLS,ISTRA)
  661 CONTINUE
      DO 662 IION=1,NIONI
        PDENII(0,ISTRA)=PDENII(0,ISTRA)+PDENII(IION,ISTRA)
        EDENII(0,ISTRA)=EDENII(0,ISTRA)+EDENII(IION,ISTRA)
        PPIOI (0,ISTRA)=PPIOI (0,ISTRA)+PPIOI (IION,ISTRA)
        PAIOI (0,ISTRA)=PAIOI (0,ISTRA)+PAIOI (IION,ISTRA)
        PMIOI (0,ISTRA)=PMIOI (0,ISTRA)+PMIOI (IION,ISTRA)
        PIIOI (0,ISTRA)=PIIOI (0,ISTRA)+PIIOI (IION,ISTRA)
        PPHIOI(0,ISTRA)=PPHIOI(0,ISTRA)+PPHIOI(IION,ISTRA)
        POTIOI(0,ISTRA)=POTIOI(0,ISTRA)+POTIOI(IION,ISTRA)
        PRFAII(0,ISTRA)=PRFAII(0,ISTRA)+PRFAII(IION,ISTRA)
        PRFMII(0,ISTRA)=PRFMII(0,ISTRA)+PRFMII(IION,ISTRA)
        PRFIII(0,ISTRA)=PRFIII(0,ISTRA)+PRFIII(IION,ISTRA)
        PRFPHII(0,ISTRA)=PRFPHII(0,ISTRA)+PRFPHII(IION,ISTRA)
        PRFPII(0,ISTRA)=PRFPII(0,ISTRA)+PRFPII(IION,ISTRA)
        EOTIOI(0,ISTRA)=EOTIOI(0,ISTRA)+EOTIOI(IION,ISTRA)
        ERFAII(0,ISTRA)=ERFAII(0,ISTRA)+ERFAII(IION,ISTRA)
        ERFMII(0,ISTRA)=ERFMII(0,ISTRA)+ERFMII(IION,ISTRA)
        ERFIII(0,ISTRA)=ERFIII(0,ISTRA)+ERFIII(IION,ISTRA)
        ERFPHII(0,ISTRA)=ERFPHII(0,ISTRA)+ERFPHII(IION,ISTRA)
        ERFPII(0,ISTRA)=ERFPII(0,ISTRA)+ERFPII(IION,ISTRA)
        SPTAIOI(0,ISTRA)=SPTAIOI(0,ISTRA)+SPTAIOI(IION,ISTRA)
        SPTMIOI(0,ISTRA)=SPTMIOI(0,ISTRA)+SPTMIOI(IION,ISTRA)
        SPTIIOI(0,ISTRA)=SPTIIOI(0,ISTRA)+SPTIIOI(IION,ISTRA)
        SPTPHIOI(0,ISTRA)=SPTPHIOI(0,ISTRA)+SPTPHIOI(IION,ISTRA)
        SPTPIOI(0,ISTRA)=SPTPIOI(0,ISTRA)+SPTPIOI(IION,ISTRA)
        PGENII(0,ISTRA)=PGENII(0,ISTRA)+PGENII(IION,ISTRA)
        EGENII(0,ISTRA)=EGENII(0,ISTRA)+EGENII(IION,ISTRA)
        VGENII(0,ISTRA)=VGENII(0,ISTRA)+VGENII(IION,ISTRA)
        EELFI (0,ISTRA)=EELFI (0,ISTRA)+EELFI (IION,ISTRA)
        VXDENII(0,ISTRA)=VXDENII(0,ISTRA)+VXDENII(IION,ISTRA)
        VYDENII(0,ISTRA)=VYDENII(0,ISTRA)+VYDENII(IION,ISTRA)
        VZDENII(0,ISTRA)=VZDENII(0,ISTRA)+VZDENII(IION,ISTRA)
        RIELI (0,ISTRA)=RIELI (0,ISTRA)+RIELI (IION,ISTRA)
  662 CONTINUE
      DO 663 IMOL=1,NMOLI
        PDENMI(0,ISTRA)=PDENMI(0,ISTRA)+PDENMI(IMOL,ISTRA)
        EDENMI(0,ISTRA)=EDENMI(0,ISTRA)+EDENMI(IMOL,ISTRA)
        PPMLI (0,ISTRA)=PPMLI (0,ISTRA)+PPMLI (IMOL,ISTRA)
        PAMLI (0,ISTRA)=PAMLI (0,ISTRA)+PAMLI (IMOL,ISTRA)
        PMMLI (0,ISTRA)=PMMLI (0,ISTRA)+PMMLI (IMOL,ISTRA)
        PIMLI (0,ISTRA)=PIMLI (0,ISTRA)+PIMLI (IMOL,ISTRA)
        PPHMLI(0,ISTRA)=PPHMLI(0,ISTRA)+PPHMLI(IMOL,ISTRA)
        POTMLI(0,ISTRA)=POTMLI(0,ISTRA)+POTMLI(IMOL,ISTRA)
        PRFAMI(0,ISTRA)=PRFAMI(0,ISTRA)+PRFAMI(IMOL,ISTRA)
        PRFMMI(0,ISTRA)=PRFMMI(0,ISTRA)+PRFMMI(IMOL,ISTRA)
        PRFIMI(0,ISTRA)=PRFIMI(0,ISTRA)+PRFIMI(IMOL,ISTRA)
        PRFPHMI(0,ISTRA)=PRFPHMI(0,ISTRA)+PRFPHMI(IMOL,ISTRA)
        PRFPMI(0,ISTRA)=PRFPMI(0,ISTRA)+PRFPMI(IMOL,ISTRA)
        EOTMLI(0,ISTRA)=EOTMLI(0,ISTRA)+EOTMLI(IMOL,ISTRA)
        ERFAMI(0,ISTRA)=ERFAMI(0,ISTRA)+ERFAMI(IMOL,ISTRA)
        ERFMMI(0,ISTRA)=ERFMMI(0,ISTRA)+ERFMMI(IMOL,ISTRA)
        ERFIMI(0,ISTRA)=ERFIMI(0,ISTRA)+ERFIMI(IMOL,ISTRA)
        ERFPHMI(0,ISTRA)=ERFPHMI(0,ISTRA)+ERFPHMI(IMOL,ISTRA)
        ERFPMI(0,ISTRA)=ERFPMI(0,ISTRA)+ERFPMI(IMOL,ISTRA)
        SPTAMLI(0,ISTRA)=SPTAMLI(0,ISTRA)+SPTAMLI(IMOL,ISTRA)
        SPTMMLI(0,ISTRA)=SPTMMLI(0,ISTRA)+SPTMMLI(IMOL,ISTRA)
        SPTIMLI(0,ISTRA)=SPTIMLI(0,ISTRA)+SPTIMLI(IMOL,ISTRA)
        SPTPHMLI(0,ISTRA)=SPTPHMLI(0,ISTRA)+SPTPHMLI(IMOL,ISTRA)
        SPTPMLI(0,ISTRA)=SPTPMLI(0,ISTRA)+SPTPMLI(IMOL,ISTRA)
        PGENMI(0,ISTRA)=PGENMI(0,ISTRA)+PGENMI(IMOL,ISTRA)
        EGENMI(0,ISTRA)=EGENMI(0,ISTRA)+EGENMI(IMOL,ISTRA)
        VGENMI(0,ISTRA)=VGENMI(0,ISTRA)+VGENMI(IMOL,ISTRA)
        VXDENMI(0,ISTRA)=VXDENMI(0,ISTRA)+VXDENMI(IMOL,ISTRA)
        VYDENMI(0,ISTRA)=VYDENMI(0,ISTRA)+VYDENMI(IMOL,ISTRA)
        VZDENMI(0,ISTRA)=VZDENMI(0,ISTRA)+VZDENMI(IMOL,ISTRA)
        RMELI (0,ISTRA)=RMELI (0,ISTRA)+RMELI (IMOL,ISTRA)
  663 CONTINUE
      DO 664 IATM=1,NATMI
        PDENAI(0,ISTRA)=PDENAI(0,ISTRA)+PDENAI(IATM,ISTRA)
        EDENAI(0,ISTRA)=EDENAI(0,ISTRA)+EDENAI(IATM,ISTRA)
        PPATI (0,ISTRA)=PPATI (0,ISTRA)+PPATI (IATM,ISTRA)
        PAATI (0,ISTRA)=PAATI (0,ISTRA)+PAATI (IATM,ISTRA)
        PMATI (0,ISTRA)=PMATI (0,ISTRA)+PMATI (IATM,ISTRA)
        PIATI (0,ISTRA)=PIATI (0,ISTRA)+PIATI (IATM,ISTRA)
        PPHATI(0,ISTRA)=PPHATI(0,ISTRA)+PPHATI(IATM,ISTRA)
        POTATI(0,ISTRA)=POTATI(0,ISTRA)+POTATI(IATM,ISTRA)
        PRFAAI(0,ISTRA)=PRFAAI(0,ISTRA)+PRFAAI(IATM,ISTRA)
        PRFMAI(0,ISTRA)=PRFMAI(0,ISTRA)+PRFMAI(IATM,ISTRA)
        PRFIAI(0,ISTRA)=PRFIAI(0,ISTRA)+PRFIAI(IATM,ISTRA)
        PRFPHAI(0,ISTRA)=PRFPHAI(0,ISTRA)+PRFPHAI(IATM,ISTRA)
        PRFPAI(0,ISTRA)=PRFPAI(0,ISTRA)+PRFPAI(IATM,ISTRA)
        EOTATI(0,ISTRA)=EOTATI(0,ISTRA)+EOTATI(IATM,ISTRA)
        ERFAAI(0,ISTRA)=ERFAAI(0,ISTRA)+ERFAAI(IATM,ISTRA)
        ERFMAI(0,ISTRA)=ERFMAI(0,ISTRA)+ERFMAI(IATM,ISTRA)
        ERFIAI(0,ISTRA)=ERFIAI(0,ISTRA)+ERFIAI(IATM,ISTRA)
        ERFPHAI(0,ISTRA)=ERFPHAI(0,ISTRA)+ERFPHAI(IATM,ISTRA)
        ERFPAI(0,ISTRA)=ERFPAI(0,ISTRA)+ERFPAI(IATM,ISTRA)
        SPTAATI(0,ISTRA)=SPTAATI(0,ISTRA)+SPTAATI(IATM,ISTRA)
        SPTMATI(0,ISTRA)=SPTMATI(0,ISTRA)+SPTMATI(IATM,ISTRA)
        SPTIATI(0,ISTRA)=SPTIATI(0,ISTRA)+SPTIATI(IATM,ISTRA)
        SPTPHATI(0,ISTRA)=SPTPHATI(0,ISTRA)+SPTPHATI(IATM,ISTRA)
        SPTPATI(0,ISTRA)=SPTPATI(0,ISTRA)+SPTPATI(IATM,ISTRA)
        PGENAI(0,ISTRA)=PGENAI(0,ISTRA)+PGENAI(IATM,ISTRA)
        EGENAI(0,ISTRA)=EGENAI(0,ISTRA)+EGENAI(IATM,ISTRA)
        VGENAI(0,ISTRA)=VGENAI(0,ISTRA)+VGENAI(IATM,ISTRA)
        VXDENAI(0,ISTRA)=VXDENAI(0,ISTRA)+VXDENAI(IATM,ISTRA)
        VYDENAI(0,ISTRA)=VYDENAI(0,ISTRA)+VYDENAI(IATM,ISTRA)
        VZDENAI(0,ISTRA)=VZDENAI(0,ISTRA)+VZDENAI(IATM,ISTRA)
        RAELI (0,ISTRA)=RAELI (0,ISTRA)+RAELI (IATM,ISTRA)
  664 CONTINUE
      DO IPHOT=1,NPHOTI
        PDENPHI (0,ISTRA)=PDENPHI (0,ISTRA)+PDENPHI (IPHOT,ISTRA)
        EDENPHI (0,ISTRA)=EDENPHI (0,ISTRA)+EDENPHI (IPHOT,ISTRA)
        PPPHTI  (0,ISTRA)=PPPHTI  (0,ISTRA)+PPPHTI  (IPHOT,ISTRA)
        PAPHTI  (0,ISTRA)=PAPHTI  (0,ISTRA)+PAPHTI  (IPHOT,ISTRA)
        PMPHTI  (0,ISTRA)=PMPHTI  (0,ISTRA)+PMPHTI  (IPHOT,ISTRA)
        PIPHTI  (0,ISTRA)=PIPHTI  (0,ISTRA)+PIPHTI  (IPHOT,ISTRA)
        PPHPHTI (0,ISTRA)=PPHPHTI (0,ISTRA)+PPHPHTI (IPHOT,ISTRA)
        POTPHTI (0,ISTRA)=POTPHTI (0,ISTRA)+POTPHTI (IPHOT,ISTRA)
        PRFAPHTI(0,ISTRA)=PRFAPHTI(0,ISTRA)+PRFAPHTI(IPHOT,ISTRA)
        PRFMPHTI(0,ISTRA)=PRFMPHTI(0,ISTRA)+PRFMPHTI(IPHOT,ISTRA)
        PRFIPHTI(0,ISTRA)=PRFIPHTI(0,ISTRA)+PRFIPHTI(IPHOT,ISTRA)
        PRFPHPHTI(0,ISTRA)=PRFPHPHTI(0,ISTRA)+PRFPHPHTI(IPHOT,ISTRA)
        PRFPPHTI(0,ISTRA)=PRFPPHTI(0,ISTRA)+PRFPPHTI(IPHOT,ISTRA)
        EOTPHTI (0,ISTRA)=EOTPHTI (0,ISTRA)+EOTPHTI (IPHOT,ISTRA)
        ERFAPHTI(0,ISTRA)=ERFAPHTI(0,ISTRA)+ERFAPHTI(IPHOT,ISTRA)
        ERFMPHTI(0,ISTRA)=ERFMPHTI(0,ISTRA)+ERFMPHTI(IPHOT,ISTRA)
        ERFIPHTI(0,ISTRA)=ERFIPHTI(0,ISTRA)+ERFIPHTI(IPHOT,ISTRA)
        ERFPHPHTI(0,ISTRA)=ERFPHPHTI(0,ISTRA)+ERFPHPHTI(IPHOT,ISTRA)
        ERFPPHTI(0,ISTRA)=ERFPPHTI(0,ISTRA)+ERFPPHTI(IPHOT,ISTRA)
        SPTAPHTI(0,ISTRA)=SPTAPHTI(0,ISTRA)+SPTAPHTI(IPHOT,ISTRA)
        SPTMPHTI(0,ISTRA)=SPTMPHTI(0,ISTRA)+SPTMPHTI(IPHOT,ISTRA)
        SPTIPHTI(0,ISTRA)=SPTIPHTI(0,ISTRA)+SPTIPHTI(IPHOT,ISTRA)
        SPTPHPHTI(0,ISTRA)=SPTPHPHTI(0,ISTRA)+SPTPHPHTI(IPHOT,ISTRA)
        SPTPPHTI(0,ISTRA)=SPTPPHTI(0,ISTRA)+SPTPPHTI(IPHOT,ISTRA)
        PGENPHI (0,ISTRA)=PGENPHI (0,ISTRA)+PGENPHI (IPHOT,ISTRA)
        EGENPHI (0,ISTRA)=EGENPHI (0,ISTRA)+EGENPHI (IPHOT,ISTRA)
        VGENPHI (0,ISTRA)=VGENPHI (0,ISTRA)+VGENPHI (IPHOT,ISTRA)
        VXDENPHI (0,ISTRA)=VXDENPHI (0,ISTRA)+VXDENPHI (IPHOT,ISTRA)
        VYDENPHI (0,ISTRA)=VYDENPHI (0,ISTRA)+VYDENPHI (IPHOT,ISTRA)
        VZDENPHI (0,ISTRA)=VZDENPHI (0,ISTRA)+VZDENPHI (IPHOT,ISTRA)
      END DO
      DO 665 IADV=1,NADVI
        ADDVI(0,ISTRA)=ADDVI(0,ISTRA)+ADDVI(IADV,ISTRA)
  665 CONTINUE
      DO 666 ICLV=1,NCLVI
        COLVI(0,ISTRA)=COLVI(0,ISTRA)+COLVI(ICLV,ISTRA)
  666 CONTINUE
      DO 667 ISNV=1,NSNVI
        SNAPVI(0,ISTRA)=SNAPVI(0,ISTRA)+SNAPVI(ISNV,ISTRA)
  667 CONTINUE
      DO 668 ICPV=1,NCPVI
        COPVI(0,ISTRA)=COPVI(0,ISTRA)+COPVI(ICPV,ISTRA)
  668 CONTINUE
      DO 669 IBGV=1,NBGVI
        BGKVI(0,ISTRA)=BGKVI(0,ISTRA)+BGKVI(IBGV,ISTRA)
  669 CONTINUE
C
      RETURN
      END SUBROUTINE EIRENE_SUM_AVERAGE
