C
C
C----------------------------------------------------------------------*
C SUBROUTINE PLTMSK                                                    *
C----------------------------------------------------------------------*
      SUBROUTINE EIRENE_PLTMSK(IERR)
C
C  PLOTPROGRAMM ZUR ERSTELLUNG EINES ZEICHENFELDES.
C  DIE EINGABEWERTE GEBEN AN WO SICH DAS FELD IM BILD BEFINDEN SOLL UND
C  WELCHE ART VON X- UND Y-ACHSE GEWUENSCHT WIRD.
C  DAS HEISST OB MIT LOGARITHMISCHER ODER LINEARER ACHSENEINTEILUNG,
C  MIT GITTERLINIEN ODER NUR MIT KURZEN MARKIERUNGEN VERSEHEN
C  ODER BESCHRIFTUNG VOM PROGRAMM ANGEPASST ODER SELBST VORGEGEBEN.
C
C  EINGABEDATEN: COMMONBLOECKE ORIGIN,XAXES,YAXES
C
C
      USE EIRMOD_CPLMSK

      IMPLICIT NONE
      INTEGER, INTENT(OUT) :: IERR
      REAL(DP) :: XMIN, XMAX, YMIN, YMAX
      INTEGER :: IAX
      EXTERNAL :: EIRENE_PLTAXI
      EXTERNAL :: GRSCLC, GRSCLV

      CALL GRSCLC(REAL(X0PL,SP),REAL(Y0PL,SP),
     .            REAL(X0PL+LENX,SP),REAL(Y0PL+LENY,SP))
C  PLOT X AXIS
      IAX=1
      CALL EIRENE_PLTAXI(IERR,IAX)
C  PLOT Y AXIS
      IAX=2
      CALL EIRENE_PLTAXI(IERR,IAX)
      IF (IERR.GT.0) RETURN
C
      IF (LOGX) THEN
         XMIN=REAL(MINLX,SP)
         XMAX=REAL(MAXLX,SP)
      ELSE
         XMIN=MINX
         XMAX=MAXX
      ENDIF
C
      IF (LOGY) THEN
         YMIN=REAL(MINLY,SP)
         YMAX=REAL(MAXLY,SP)
      ELSE
         YMIN=MINY
         YMAX=MAXY
      ENDIF
C
      CALL GRSCLV(REAL(XMIN,SP),REAL(YMIN,SP),
     .            REAL(XMAX,SP),REAL(YMAX,SP))
C
      RETURN
      END SUBROUTINE EIRENE_PLTMSK
