C  sept.2014: very minor coding clean-up.
C
      SUBROUTINE EIRENE_FMAXWL
C
C  SAMPLE IRNDVC RANDOM NUMBERS FROM A GAUSSIAN FLUX V*FMAX(V)
C  AND RETURN THEM THE ARRAY FM1
C  SAMPLE IRNDVC PAIRS OF RANDOM NUMBER FROM A GAUSSIAN
C  AND RETURN THEM IN THE ARRAYS FM2 AND FM3
C  THIS ROUTINE IS CALLED WHEN INIV1.EQ.0. IT RESETS INIV1=IRNDVC
C
      USE EIRMOD_CRAND
      USE EIRMOD_RANF, ONLY: RANF_EIRENE
      USE EIRMOD_CCONA, ONLY: PI2 => PI2A

      IMPLICIT NONE

      REAL(DP) :: ZCOS, ZSIN, ZT, AR, ZZ
      INTEGER :: JJ

!pb   DATA PI2/6.283185_DP/
C
C  THIS FUNCTION SAMPLES FROM A GAUSSIAN OF THE
C  FORM EXP(-(X-ZA)**2/(2.*ZS**2))/(ZS*SQRT(2*PI))
C  ZA=0.
C  ZS=1.
C
C  IT IS THE BOX-MUELLER METHOD
C
C
      DO 1 JJ=1,IRNDVC
C   1. COMPUTE THE SINE AND COSINE OF 2*PI*RAN(1)
C
        ZZ=PI2*RANF_EIRENE( )
        ZSIN=SIN(ZZ)
        ZCOS=COS(ZZ)
C
        AR=LOG(RANF_EIRENE( ))
        ZT=SQRT(-(AR+AR))
        FM2(JJ)=ZT*ZSIN
        FM3(JJ)=ZT*ZCOS
    1 CONTINUE
C
C  SAMPLE FROM MAXWELLIAN FLUX BY INVERSION RULE
C
      DO 2 JJ=1,IRNDVC
        AR=LOG(RANF_EIRENE( ))
        ZT=SQRT(-(AR+AR))
        FM1(JJ)=ZT
    2 CONTINUE
      INIV1=IRNDVC
      RETURN
      END SUBROUTINE EIRENE_FMAXWL
