      subroutine eirene_init_params
C
C  SET DEFAULT VALUES FOR STORAGE PARAMETERS
C

      USE EIRMOD_PRECISION
      USE EIRMOD_PARMMOD
      USE EIRMOD_COMUSR

      IMPLICIT NONE

C  GEOMETRY
      N1ST=1
      N2ND=1
      N3RD=1
      NADD=0
      NTOR=1
      NRTAL=0
      NLIM=1
      NSTS=1
      NPLG=1
      NPPART=1
      NKNOT=1
      NTRI=1
!     NTRII=0
      NTETRA=1
      NCOORD=1
C  PRIMARY SOURCE
      NSTRA=1
      NSRFS=1
      NSTEP=1
      NGITT=0
      NPTRGT=1
C  TEST PARTICLE SPECIES AND TALLIES
      NATM=0
      NMOL=0
      NION=0
      NPLS=1
      NPHOT=0

      NADV=0
      NADS=0
      NCLV=0
      NSNV=0
      NALV=0
      NALS=0
      NAIN=0
      NCPV=0
      NBGK=0
      NADSPC=0
C  BACKGROUND PARTICLE SPECIES AND TALLIES
!     LMULPL= .FALSE.
      NPLSTI=1
      NPLSV=1
C  STATISTICS
      NSD=1
      NSDW=1
      NCV=1
C  ATOMIC DATA
      NREAC=1
c  total no. of reaction cards read in block 4
      NREAC_LINES=0
      NREC=1
      NREI=1
      NRCX=1
      NREL=1
      NRPI=1
C
C  LINE-OF-SIGHT DIAGNOSTICS
      NCHOR=0
      NCHEN=0
      NPRNL=0
      NVLPR=0
      NSRPR=0
C  2D CFD INTERFACE

cdr STORAGE FOR COUPLING TO 2D CFD CODES: COMMON 2D GRID SIZE, BACKGROUND FLUIDS, TARGET RECYCLING
C   CORRECT PARAMETERS  MUST BE SET IN INTERFACING TO CFD CODE, MODULE.  INTERFACES/COUPLE_../IF0PRM.f
c   ONLY INITIALIZE HERE (e.g. for standalone runs or code coupling to other than 2D CFD codes)
      NDX=0
      NDY=0
      NFL=0
      NPTRGT=0
      NDXP=1
      NDYP=1

C  OPTIMIZATION OF GEOMETRICAL CALCULATIONS: STORAGE FOR IGJUM3(NCELL,NSURF)
C  ALSO AFFECTS ARRAYS NLIMI(NCELL), NLIME(NCELL) OPTIMIZATION OF CALLS TO TIMEA.F
C  NOPTIM=1   IGJUM3 AND NLIMI, NLIME ARRAYS ARE REMOVED, NO OPTIMIZATION
C  ELSE: STORAGE IS PROVIDED, CH3 OPTIONS CAN BE USED, IGJUM3(NOPTIM,NSURF), ETC.
      NOPTIM=1  ! DEFAULT WILL BE AUTOMATICALLY SET TO NRAD,
                ! BELOW, LDEFSTOR

C  BIT ARITHMETIC FOR (LARGE) IGJUM.. ARRAYS: ONLY VALUES 0 OR 1 ARE ON THESE ARRAYS
C  NOPTM1=1   USE REGULAR INTEGER (32 BIT = 4 BYTE) PER FLAG
C  NOPTM1>1   USE A SINGLE BIT PER FLAG, STORE NOPTM1 FLAGS ON A REGULAR INTEGER
      NOPTM1=1

C  USER-DEFINED GEOMETRY (LEVGEO=10)?
C  NGEOM_USR = 1  ==> STORAGE PROVIDED FOR USER-DEFINED GEOMETRY OPTION
C  NGEOM_USR = 0  ==> NO STORAGE FOR USER-DEFINED GEOMETRY
      NGEOM_USR=0   ! LDEFSTOR: SHOULD BE MADE DEPENDENT ON
                    !           WHETHER LEVGEO=10 OR NOT

C  Input from coupling routine
C  NCOUP_INPUT = 0  ==> NO PLASMA INPUT FROM COUPLING ROUTINE
C  NCOUP_INPUT = 1  ==> PLASMA INPUT FROM COUPLING ROUTINE
      NCOUP_INPUT = 1

C  Sum over Strata
C  NSMSTRA = 0  ==> SUM OVER STRATA IS NOT PERFORMED
C  NSMSTRA = 1  ==> SUM OVER STRATA IS PERFORMED
      NSMSTRA=1
C
C  CALCULATION OR STORAGE OF ATOMIC DATA
C  NSTORAM=0,9.    =0: MINIMUM STORAGE, MAXIMUM CALCULATION
C                  =9: MAXIMUM STORAGE, MINIMUM CALCULATION
      NSTORAM=9
C
C  SPATIALLY RESOLVED SURFACE TALLIES?
C  NGSTAL = 0  ==> NO SPACE FOR SPATIALLY RESOLVED SURFACE TALLIES
C  NGSTAL = 1  ==> SPATIALLY RESOLVED SURFACE TALLIES ARE COMPUTED
      NGSTAL=0

C  NUMBER OF BACKGROUND SPECTRA
      NBACK_SPEC=0

      return
      end subroutine eirene_init_params
