      SUBROUTINE EIRENE_SET_SPECIFIC_ZONES

      USE EIRMOD_PRECISION
      USE EIRMOD_PARMMOD
      USE EIRMOD_COMUSR
      USE EIRMOD_CCONA

      IMPLICIT NONE

      TYPE(TEMPERATURE),POINTER :: TEMPCUR
      TYPE(DENSITY),POINTER :: DENCUR
      TYPE(VELOCITY),POINTER :: VELCUR
      INTEGER :: IPLSTI, IPLS, IPLSV, J

      DO WHILE (ASSOCIATED(TEMPLIST))
        TEIN(TEMPLIST%II) = TEMPLIST%TE
        IPLSTI = MPLSTI(TEMPLIST%IDION)
        TIIN(IPLSTI,TEMPLIST%II) = TEMPLIST%TI
        TEMPCUR => TEMPLIST
        TEMPLIST => TEMPLIST%NEXT
        DEALLOCATE(TEMPCUR)
      ENDDO

      DO WHILE (ASSOCIATED(DENLIST))
        DIIN(DENLIST%IDION,DENLIST%II) = DENLIST%DI
        DENCUR => DENLIST
        DENLIST => DENLIST%NEXT
        DEALLOCATE(DENCUR)
      ENDDO

      DO WHILE (ASSOCIATED(VELLIST))
        IPLS = VELLIST%IDION
        IPLSTI = MPLSTI(IPLS)
        IPLSV = MPLSV(IPLS)
        J = VELLIST%II
        VXIN(IPLSV,J) = VELLIST%VX
        VYIN(IPLSV,J) = VELLIST%VY
        VZIN(IPLSV,J) = VELLIST%VZ
        IF (VELLIST%IZ .EQ. 1) THEN
          VXIN(IPLSV,J)=CVEL2A*VXIN(IPLSV,J)*
     .                  SQRT((TEIN(J)+TIIN(IPLSTI,J))/RMASSP(IPLS))
          VYIN(IPLSV,J)=CVEL2A*VYIN(IPLSV,J)*
     .                  SQRT((TEIN(J)+TIIN(IPLSTI,J))/RMASSP(IPLS))
          VZIN(IPLSV,J)=CVEL2A*VZIN(IPLSV,J)*
     .                  SQRT((TEIN(J)+TIIN(IPLSTI,J))/RMASSP(IPLS))
        ENDIF
        VELCUR => VELLIST
        VELLIST => VELLIST%NEXT
        DEALLOCATE(VELCUR)
      ENDDO

      RETURN
      END SUBROUTINE EIRENE_SET_SPECIFIC_ZONES
