
      SUBROUTINE EIRENE_VECUSR (I,IC,X,Y,Z,VEC_X,VEC_Y,VEC_Z,IPL,L)

c  L=.true. : This call is at known position x,y,z, in cell IC.
c  L=.false.: This call is in cell ic. Return value at center of gravity of this cell

c  I=1: return local B field vector as vec_x,vec_y,vec_z
c  I=2: return local plasma drift velocity vector of eirene background species "ipls"
c              as vec_x,vec_y,vec_z
c  note: ipls is the true background species,
c        not to be confused with the mapped species index mplsv(ipls)
      USE EIRMOD_PRECISION
      USE EIRMOD_PARMMOD
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: I, IC,IPL
      LOGICAL             :: L
      REAL(DP), INTENT(IN) :: X,Y,Z
      REAL(DP), INTENT(OUT) :: VEC_X,VEC_Y,VEC_Z
c
c   return default vector: (0.,0.,1.)
      VEC_X=0.0
      VEC_Y=0.0
      VEC_Z=1.0
      RETURN
      END SUBROUTINE EIRENE_VECUSR
